SystemOrganization addCategory: #'SCouchDB-JQuery-Core'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Test'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Test-Functional'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Test-Functional-mobile'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Lib'!

JQPlugin subclass: #JQCouch
	instanceVariableNames: 'couchFunction command database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Core'!

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:47'!
activeTasks
self command:'activeTasks'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:23'!
allApps
self command:'allApps'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 14:30'!
allDbs
	self command:'allDbs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:14'!
allDesignDocs
self command:'allDesignDocs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 19:02'!
allDocs
self command:'allDocs'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 4/3/2012 19:33'!
arguments
	| arguments jSonOptions|
	arguments := OrderedCollection new.
	jSonOptions:=Dictionary new.
	self options
		at: 'success'
		ifPresent: [ :value | jSonOptions at:'success' put: value ].
	self options
		at: 'eachApp'
		ifPresent: [ :value | jSonOptions at:'eachApp' put: value ].
	self options
		at: 'loginpassword'
		ifPresent: [ :value | jSonOptions at:'password' put: value ].
	self options
		at: 'name'
		ifPresent: [ :value | jSonOptions at:'name' put: value ].
	self options
		at: 'error'
		ifPresent: [ :value | jSonOptions at:'error' put: value ].
	self options
		at: 'reduce'
		ifPresent: [ :value | jSonOptions at:'reduce' put: value ].
	self options
		at: 'view'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'list'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'change'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'successUserDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'userDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'password'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'replicateDb'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateNewDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'doc'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'bulkDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'mapFunction'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'reduceFunction'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'language'
		ifPresent: [ :value | arguments add: value ].	
							
	(jSonOptions size>0) ifTrue:[arguments add:jSonOptions].
	"this options after succcess...stupid order..."
	
	self options
		at: 'section'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option-value'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateTarget'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'beforeSend'
		ifPresent: [ :value | arguments add: value ].				
	^ arguments! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:37'!
beforeSend:aDocument 
"aDocument is a JSon doc with the beforeSend property that contains a jscript function"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'beforeSend' put:( aDocument asFunction:#(xhr)).
	options at:'beforeSend' put:aDoc	
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/17/2013 08:50'!
bulkRemove:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	
	self command:'bulkRemove'.
	self optionAt: 'bulkDoc' put: aDocument.
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/17/2013 08:47'!
bulkSave:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	

	self command:'bulkSave'.
	self optionAt: 'bulkDoc' put: aDocument
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command
	^ command! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command: anObject
	command := anObject! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:03'!
compact
self command:'compact'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:13'!
compactView:aView
"aView name example: 'default/all'"
	
	self command:'compactView'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:57'!
config:aSection option:anOption
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:58'!
config:aSection option:anOption value:aValue
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption.
self options at:'option-value' put:aValue! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:11'!
copyDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'copyDoc'.
	self optionAt: 'doc' put: (aDocument).
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 22:38'!
couchFunction
	^ couchFunction! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 01:16'!
couchFunction: aFunction
(aFunction isKindOf: BlockClosure)
ifTrue:[	couchFunction:= ((aFunction value)greaseString)]
ifFalse:[	couchFunction := aFunction ]! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:24'!
create
command:='create'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:22'!
database
	^ Array with:database! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:23'!
database: anString
	database := anString.
	self couchFunction: [(JSStream on:'db') call:'' withArguments:(self database)].! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:25'!
db:aDatabase

self database:aDatabase! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 19:21'!
drop
command:='drop'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 2/13/2013 00:59'!
encodeDocId: anString
	self couchFunction: [(JSStream on:'encodeDocId') call:'' withArguments:(Array with:anString)].
	   ! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:20'!
forEachApp: anObject
	self optionAt: 'eachApp' put: (anObject asFunction:#(appName appPath ddoc)).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 13:44'!
info
self command:'info'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 7/24/2012 16:51'!
javascriptContentOn: aStream

	aStream
		javascript: self owner;
		nextPut: $.;
		nextPutAll: self method.
	
	couchFunction notNil ifTrue:[ 
		aStream  nextPut:$.;nextPutAll:couchFunction].
	command notNil ifTrue:[ 
		aStream nextPut:$. ;nextPutAll:command].
	self options size>0 ifTrue:[
		JSStream encodeArguments: self arguments on: aStream
		].
	"aStream nextPut:$;"
	
		
	! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:00'!
list:aView with:aList
"list a view with aList function'"
	
	self command:'list'.
	self optionAt: 'view' put: aView.
	self optionAt: 'list' put: aList.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:33'!
login:aUserName password:anString
"anUserName and password must be anString"

	self command:'login'.
	self optionAt: 'name' put: aUserName.
	self optionAt:'loginpassword' put: anString! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:45'!
logout
self command:'logout'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 23:19'!
method
	^ 'couch'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/5/2012 05:54'!
newUUID
self command:'newUUID()'.! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 18:36'!
onChange: anObject
	self command:'changes().onChange'.
	self optionAt: 'change' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 3/31/2012 17:23'!
onError: anObject
	self optionAt: 'error' put: (anObject asFunction:#(status)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 2/1/2013 13:15'!
onSuccess: anObject
	self optionAt: 'success' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:07'!
openDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'openDoc'.
	self optionAt: 'doc' put:aDocument.
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:33'!
query:mapFunction 
self query:mapFunction reduceFunction:'_count' language:'javascript'reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction 
self query:mapFunction reduceFunction:reduceFunction language:'javascript' reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction language:language 
self query:mapFunction reduceFunction:reduceFunction language:language reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:24'!
query:mapFunction reduceFunction:reduceFunction language:language reduce:aBoolean
self command:'query'.
self optionAt: 'mapFunction' put: mapFunction.
self optionAt: 'reduceFunction' put: reduceFunction. 
self optionAt: 'language' put: language.
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:50'!
reduce:aBoolean
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:12'!
removeDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'removeDoc'.
	self optionAt: 'doc' put: (aDocument).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/1/2012 09:09'!
replicate:aDatabase to:aNewDatabase createTarget:aBoolean
"create_target must be a Dictionary wuth the following entrances:
{create_target:true}"
|createTarget|
	createTarget:=Dictionary new.
	createTarget at:'create_target' put: aBoolean.

	self command:'replicate'.
	self optionAt: 'replicateDb' put: aDatabase.
	self optionAt: 'replicateNewDb' put: aNewDatabase.
	self optionAt: 'replicateTarget' put: createTarget.! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:09'!
saveDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	self command:'saveDoc'.
	self optionAt: 'doc' put: (aDocument).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:44'!
session
self command:'session'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:21'!
signUp:aUserName password:anString
"anUserDoc must be a Dictionary wuth the following entrances:
{_id:'org.couchdb.user:bob' , name:'bob'}"
|aUserDoc|
	aUserDoc:=Dictionary new.
	aUserDoc at:'_id' put: ('org.couchdb.user:',aUserName).
	aUserDoc at:'name' put:aUserName.
	self command:'signup'.
	self optionAt: 'userDoc' put: aUserDoc.
	self optionAt: 'password' put: anString.! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 2/13/2013 00:29'!
urlPrefix
		self couchFunction: [(JSStream on:'urlPrefix')].
	! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 4/5/2012 05:58'!
urlPrefix: anObject
		self couchFunction: [(JSStream on:'urlPrefix="',anObject,'"')].
	! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 17:00'!
userDb:aFunction
self command:'userDb'.
self optionAt: 'successUserDb' put: (aFunction asFunction:#(data)).! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:34'!
view:aView
"aView name example: 'default/all'"
	
	self command:'view'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/3/2012 18:08'!
viewCleanup
self command:'viewCleanup'! !

!JQueryClass methodsFor: '*SCouchdb-JQuery' stamp: 'JesusMari 3/30/2012 23:17'!
couch
	^ self create: JQCouch! !

WAFileLibrary subclass: #JQCouchDBDevelopmentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Lib'!

!JQCouchDBDevelopmentLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/14/2013 18:17'!
jqueryattachementsHandlingJs
^'
function attachmentsToArray(doc){
	if (!!doc._attachments) {return doc};
	doc._attachments= $.map(doc._attachments, function(v,k){
									return { "filename": k, "value": v}});
	return doc
}'! !

!JQCouchDBDevelopmentLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/24/2012 16:48'!
jquerycouchJs 
^'// Licensed under the Apache License, Version 2.0 (the "License"); you may not
// use this file except in compliance with the License. You may obtain a copy of
// the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations under
// the License.

/**
 * @namespace
 * $.couch is used to communicate with a CouchDB server, the server methods can
 * be called directly without creating an instance. Typically all methods are
 * passed an <code>options</code> object which defines a success callback which
 * is called with the data returned from the http request to CouchDB, you can
 * find the other settings that can be used in the <code>options</code> object
 * from <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
 * jQuery.ajax settings</a>
 * <pre><code>$.couch.activeTasks({
 *   success: function (data) {
 *     console.log(data);
 *   }
 * });</code></pre>
 * Outputs (for example):
 * <pre><code>[
 *  {
 *   "pid" : "<0.11599.0>",
 *   "status" : "Copied 0 of 18369 changes (0%)",
 *   "task" : "recipes",
 *   "type" : "Database Compaction"
 *  }
 *]</code></pre>
 */
(function($) {

  $.couch = $.couch || {};
  /** @lends $.couch */

  /**
   * @private
   */
  function encodeDocId(docID) {
    var parts = docID.split("/");
    if (parts[0] == "_design") {
      parts.shift();
      return "_design/" + encodeURIComponent(parts.join(''/''));
    }
    return encodeURIComponent(docID);
  }

  /**
   * @private
   */

  var uuidCache = [];

  $.extend($.couch, {
    urlPrefix: '''',

    /**
     * You can obtain a list of active tasks by using the /_active_tasks URL.
     * The result is a JSON array of the currently running tasks, with each task
     * being described with a single object.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_active-task
     * s_get">docs for /_active_tasks</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/jQuery.ajax
     * /#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    activeTasks: function(options) {
      ajax(
        {url: this.urlPrefix + "/_active_tasks"},
        options,
        "Active task status could not be retrieved"
      );
    },

    /**
     * Returns a list of all the databases in the CouchDB instance
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_active-task
     * s_get">docs for /_all_dbs</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/jQuery.ajax
     * /#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    allDbs: function(options) {
      ajax(
        {url: this.urlPrefix + "/_all_dbs"},
        options,
        "An error occurred retrieving the list of all databases"
      );
    },

    /**
     * View and edit the CouchDB configuration, called with just the options
     * parameter the entire config is returned, you can be more specific by
     * passing the section and option parameters, if you specify a value that
     * value will be stored in the configuration.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-config.html#couchbase-api-config_config
     * -section-key_put">docs for /_config</a>
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     * @param {String} [section] the section of the config
     * @param {String} [option] the particular config option
     * @param {String} [value] value to be set
     */
    config: function(options, section, option, value) {
      var req = {url: this.urlPrefix + "/_config/"};
      if (section) {
        req.url += encodeURIComponent(section) + "/";
        if (option) {
          req.url += encodeURIComponent(option);
        }
      }
      if (value === null) {
        req.type = "DELETE";        
      } else if (value !!== undefined) {
        req.type = "PUT";
        req.data = toJSON(value);
        req.contentType = "application/json";
        req.processData = false
      }

      ajax(req, options,
        "An error occurred retrieving/updating the server configuration"
      );
    },
    
    /**
     * Returns the session information for the currently logged in user.
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    session: function(options) {
      options = options || {};
      $.ajax({
        type: "GET", url: this.urlPrefix + "/_session",
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw "An error occurred getting session info: " + resp.reason;
          }
        }
      });
    },

    /**
     * @private
     */
    userDb : function(callback) {
      $.couch.session({
        success : function(resp) {
          var userDb = $.couch.db(resp.info.authentication_db);
          callback(userDb);
        }
      });
    },

    /**
     * Create a new user on the CouchDB server, <code>user_doc</code> is an
     * object with a <code>name</code> field and other information you want
     * to store relating to that user, for example
     * <code>{"name": "daleharvey"}</code>
     * @param {Object} user_doc Users details
     * @param {String} password Users password
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
      * jQuery ajax settings</a>
     */
    signup: function(user_doc, password, options) {      
      options = options || {};
      user_doc.password = password;
      user_doc.roles =  user_doc.roles || [];
      user_doc.type =  user_doc.type = "user" || [];
      var user_prefix = "org.couchdb.user:";
      user_doc._id = user_doc._id || user_prefix + user_doc.name;

      $.couch.userDb(function(db) {
        db.saveDoc(user_doc, options);
      });
    },

    /**
     * Authenticate against CouchDB, the <code>options</code> parameter is
      *expected to have <code>name</code> and <code>password</code> fields.
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    login: function(options) {
      options = options || {};
      $.ajax({
        type: "POST", url: this.urlPrefix + "/_session", dataType: "json",
        data: {name: options.name, password: options.password},
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw ''An error occurred logging in: '' + resp.reason;
          }
        }
      });
    },


    /**
     * Delete your current CouchDB user session
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    logout: function(options) {
      options = options || {};
      $.ajax({
        type: "DELETE", url: this.urlPrefix + "/_session", dataType: "json",
        username : "_", password : "_",
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw ''An error occurred logging out: '' + resp.reason;
          }
        }
      });
    },

    /**
     * @namespace
     * $.couch.db is used to communicate with a specific CouchDB database
     * <pre><code>var $db = $.couch.db("mydatabase");
     *$db.allApps({
     *  success: function (data) {
     *    ... process data ...
     *  }
     *});
     * </code></pre>
     */
    db: function(name, db_opts) {
      db_opts = db_opts || {};
      var rawDocs = {};
      function maybeApplyVersion(doc) {
        if (doc._id && doc._rev && rawDocs[doc._id] &&
            rawDocs[doc._id].rev == doc._rev) {
          // todo: can we use commonjs require here?
          if (typeof Base64 == "undefined") {
            throw ''Base64 support not found.'';
          } else {
            doc._attachments = doc._attachments || {};
            doc._attachments["rev-"+doc._rev.split("-")[0]] = {
              content_type :"application/json",
              data : Base64.encode(rawDocs[doc._id].raw)
            };
            return true;
          }
        }
      };
      return /** @lends $.couch.db */{
        name: name,
        uri: this.urlPrefix + "/" + encodeURIComponent(name) + "/",

        /**
         * Request compaction of the specified database.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-compact_post">docs for /db/_compact</a>
         * @param {ajaxSettings} options
         * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
         * jQuery ajax settings</a>
         */
        compact: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact",
              data: "", processData: false
            },
            options,
            "The database could not be compacted"
          );
        },

        /**
         * Cleans up the cached view output on disk for a given view.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db-view-cleanup_post">docs for /db/_compact</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        viewCleanup: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_view_cleanup",
              data: "", processData: false
            },
            options,
            "The views could not be cleaned up"
          );
        },

        /**
         * Compacts the view indexes associated with the specified design
         * document. You can use this in place of the full database compaction
         * if you know a specific set of view indexes have been affected by a
         * recent database change.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/upl
         * oads/all/documentation/couchbase-api-db.html#couchbase-api-db_db-
         * compact-design-doc_post">docs for /db/_compact/design-doc</a>
         * @param {String} groupname Name of design-doc to compact
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        compactView: function(groupname, options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact/" + groupname,
              data: "", processData: false
            },
            options,
            "The view could not be compacted"
          );
        },

        /**
         * Create a new database
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db_put">docs for PUT /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        create: function(options) {
          $.extend(options, {successStatus: 201});
          ajax({
              type: "PUT", url: this.uri, contentType: "application/json",
              data: "", processData: false
            },
            options,
            "The database could not be created"
          );
        },

        /**
         * Deletes the specified database, and all the documents and
         * attachments contained within it.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db_delete">docs for DELETE /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        drop: function(options) {
          ajax(
            {type: "DELETE", url: this.uri},
            options,
            "The database could not be deleted"
          );
        },

        /**
         * Gets information about the specified database.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db_get">docs for GET /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        info: function(options) {
          ajax(
            {url: this.uri},
            options,
            "Database information could not be retrieved"
          );
        },

        /**
         * @namespace
         * $.couch.db.changes provides an API for subscribing to the changes
         * feed
         * <pre><code>var $changes = $.couch.db("mydatabase").changes();
         *$changes.onChange = function (data) {
         *    ... process data ...
         * }
         * $changes.stop();
         * </code></pre>
         */
        changes: function(since, options) {

          options = options || {};
          // set up the promise object within a closure for this handler
          var timeout = 100, db = this, active = true,
            listeners = [],
            promise = /** @lends $.couch.db.changes */ {
              /**
               * Add a listener callback
               * @see <a href="http://techzone.couchbase.com/sites/default/
               * files/uploads/all/documentation/couchbase-api-db.html#couch
               * base-api-db_db-changes_get">docs for /db/_changes</a>
               * @param {Function} fun Callback function to run when
               * notified of changes.
               */
            onChange : function(fun) {
              listeners.push(fun);
            },
              /**
               * Stop subscribing to the changes feed
               */
            stop : function() {
              active = false;
            }
          };
          // call each listener when there is a change
          function triggerListeners(resp) {
            $.each(listeners, function() {
              this(resp);
            });
          };
          // when there is a change, call any listeners, then check for
          // another change
          options.success = function(resp) {
            timeout = 100;
            if (active) {
              since = resp.last_seq;
              triggerListeners(resp);
              getChangesSince();
            };
          };
          options.error = function() {
            if (active) {
              setTimeout(getChangesSince, timeout);
              timeout = timeout * 2;
            }
          };
          // actually make the changes request
          function getChangesSince() {
            var opts = $.extend({heartbeat : 10 * 1000}, options, {
              feed : "longpoll",
              since : since
            });
            ajax(
              {url: db.uri + "_changes"+encodeOptions(opts)},
              options,
              "Error connecting to "+db.uri+"/_changes."
            );
          }
          // start the first request
          if (since) {
            getChangesSince();
          } else {
            db.info({
              success : function(info) {
                since = info.update_seq;
                getChangesSince();
              }
            });
          }
          return promise;
        },

        /**
         * Fetch all the docs in this db, you can specify an array of keys to
         * fetch by passing the <code>keys</code> field in the
         * <code>options</code>
         * parameter.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-all-docs_get">docs for /db/all_docs/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allDocs: function(options) {
          var type = "GET";
          var data = null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_all_docs" + encodeOptions(options)
            },
            options,
            "An error occurred retrieving a list of all documents"
          );
        },

        /**
         * Fetch all the design docs in this db
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allDesignDocs: function(options) {
          this.allDocs($.extend(
            {startkey:"_design", endkey:"_design0"}, options));
        },

        /**
         * Fetch all the design docs with an index.html, <code>options</code>
         * parameter expects an <code>eachApp</code> field which is a callback
         * called on each app found.
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allApps: function(options) {
          options = options || {};
          var self = this;
          if (options.eachApp) {
            this.allDesignDocs({
              success: function(resp) {
                $.each(resp.rows, function() {
                  self.openDoc(this.id, {
                    success: function(ddoc) {
                      var index, appPath, appName = ddoc._id.split(''/'');
                      appName.shift();
                      appName = appName.join(''/'');
                      index = ddoc.couchapp && ddoc.couchapp.index;
                      if (index) {
                        appPath = ['''', name, ddoc._id, index].join(''/'');
                      } else if (ddoc._attachments &&
                                 ddoc._attachments["index.html"]) {
                        appPath = ['''', name, ddoc._id, "index.html"].join(''/'');
                      }
                      if (appPath) options.eachApp(appName, appPath, ddoc);
                    }
                  });
                });
              }
            });
          } else {
            throw ''Please provide an eachApp function for allApps()'';
          }
        },

        /**
         * Returns the specified doc from the specified db.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db-doc_get">docs for GET /db/doc</a>
         * @param {String} docId id of document to fetch
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        openDoc: function(docId, options, ajaxOptions) {
          options = options || {};
          if (db_opts.attachPrevRev || options.attachPrevRev) {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                rawDocs[doc._id] = {
                  rev : doc._rev,
                  raw : req.responseText
                };
              }
            });
          } else {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                if (doc["jquery.couch.attachPrevRev"]) {
                  rawDocs[doc._id] = {
                    rev : doc._rev,
                    raw : req.responseText
                  };
                }
              }
            });
          }
          ajax({url: this.uri + encodeDocId(docId) + encodeOptions(options)},
            options,
            "The document could not be retrieved",
            ajaxOptions
          );
        },

        /**
         * Create a new document in the specified database, using the supplied
         * JSON document structure. If the JSON structure includes the _id
         * field, then the document will be created with the specified document
         * ID. If the _id field is not specified, a new unique ID will be
         * generated.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db_post">docs for GET /db/doc</a>
         * @param {String} doc document to save
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        saveDoc: function(doc, options) {
          options = options || {};
          var db = this;
          var beforeSend = fullCommit(options);
          if (doc._id === undefined) {
            var method = "POST";
            var uri = this.uri;
          } else {
            var method = "PUT";
            var uri = this.uri + encodeDocId(doc._id);
          }
          var versioned = maybeApplyVersion(doc);
          $.ajax({
            type: method, url: uri + encodeOptions(options),
            contentType: "application/json",
            dataType: "json", data: toJSON(doc),
            beforeSend : beforeSend,
            complete: function(req) {
              var resp = $.parseJSON(req.responseText);
              if (req.status == 200 || req.status == 201 || req.status == 202) {
                doc._id = resp.id;
                doc._rev = resp.rev;
                if (versioned) {
                  db.openDoc(doc._id, {
                    attachPrevRev : true,
                    success : function(d) {
                      doc._attachments = d._attachments;
                      if (options.success) options.success(resp);
                    }
                  });
                } else {
                  if (options.success) options.success(resp);
                }
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                throw "The document could not be saved: " + resp.reason;
              }
            }
          });
        },

        /**
         * Save a list of documents
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-bulk-docs_post">docs for /db/_bulk_docs</a>
         * @param {Object[]} docs List of documents to save
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        bulkSave: function(docs, options) {
          var beforeSend = fullCommit(options);
          $.extend(options, {successStatus: 201, beforeSend : beforeSend});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              contentType: "application/json", data: toJSON(docs)
            },
            options,
            "The documents could not be saved"
          );
        },

        /**
         * Deletes the specified document from the database. You must supply
         * the current (latest) revision and <code>id</code> of the document
         * to delete eg <code>removeDoc({_id:"mydoc", _rev: "1-2345"})</code>
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api
         * -dbdoc_db-doc_delete">docs for DELETE /db/doc</a>
         * @param {Object} doc Document to delete
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        removeDoc: function(doc, options) {
          ajax({
              type: "DELETE",
              url: this.uri +
                   encodeDocId(doc._id) +
                   encodeOptions({rev: doc._rev})
            },
            options,
            "The document could not be deleted"
          );
        },

        /**
         * Remove a set of documents
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-bulk-docs_post">docs for /db/_bulk_docs</a>
         * @param {String[]} docs List of document id''s to remove
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        bulkRemove: function(docs, options){
          docs.docs = $.each(
            docs.docs, function(i, doc){
              doc._deleted = true;
            }
          );
          $.extend(options, {successStatus: 201});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              data: toJSON(docs)
            },
            options,
            "The documents could not be deleted"
          );
        },

        /**
         * The COPY command (which is non-standard HTTP) copies an existing
         * document to a new or existing document.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db-doc_copy">docs for COPY /db/doc</a>
         * @param {String[]} docId document id to copy
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        copyDoc: function(docId, options, ajaxOptions) {
          ajaxOptions = $.extend(ajaxOptions, {
            complete: function(req) {
              var resp = $.parseJSON(req.responseText);
              if (req.status == 201) {
                if (options.success) options.success(resp);
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                throw "The document could not be copied: " + resp.reason;
              }
            }
          });
          ajax({
              type: "COPY",
              url: this.uri + encodeDocId(docId)
            },
            options,
            "The document could not be copied",
            ajaxOptions
          );
        },

        /**
         * Creates (and executes) a temporary view based on the view function
         * supplied in the JSON request.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db-temp-view_post">docs for /db/_temp_view</a>
         * @param {Function} mapFun Map function
         * @param {Function} reduceFun Reduce function
         * @param {Function} language Language the map / reduce funs are
         * implemented in
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        query: function(mapFun, reduceFun, language, options) {
          language = language || "javascript";
          if (typeof(mapFun) !!== "string") {
            mapFun = mapFun.toSource ? mapFun.toSource()
              : "(" + mapFun.toString() + ")";
          }
          var body = {language: language, map: mapFun};
          if (reduceFun !!= null) {
            if (typeof(reduceFun) !!== "string")
              reduceFun = reduceFun.toSource ? reduceFun.toSource()
                : "(" + reduceFun.toString() + ")";
            body.reduce = reduceFun;
          }
          ajax({
              type: "POST",
              url: this.uri + "_temp_view" + encodeOptions(options),
              contentType: "application/json", data: toJSON(body)
            },
            options,
            "An error occurred querying the database"
          );
        },

        /**
         * Fetch a _list view output, you can specify a list of
         * <code>keys</code> in the options object to recieve only those keys.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-design.html#couchbase-api
         * -design_db-design-designdoc-list-listname-viewname_get">
         * docs for /db/_design/design-doc/_list/l1/v1</a>
         * @param {String} list Listname in the form of ddoc/listname
         * @param {String} view View to run list against
         * @param {options} CouchDB <a href="http://wiki.apache.org/couchdb/
         * HTTP_view_API">View Options</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        list: function(list, view, options, ajaxOptions) {
          var list = list.split(''/'');
          var options = options || {};
          var type = ''GET'';
          var data = null;
          if (options[''keys'']) {
            type = ''POST'';
            var keys = options[''keys''];
            delete options[''keys''];
            data = toJSON({''keys'': keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + ''_design/'' + list[0] +
                   ''/_list/'' + list[1] + ''/'' + view + encodeOptions(options)
              },
              ajaxOptions, ''An error occured accessing the list''
          );
        },

        /**
         * Executes the specified view-name from the specified design-doc
         * design document, you can specify a list of <code>keys</code>
         * in the options object to recieve only those keys.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-design.html#couchbase-api-
         * design_db-design-designdoc-view-viewname_get">docs for /db/
         * _design/design-doc/_list/l1/v1</a>
         * @param {String} name View to run list against
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        view: function(name, options) {
          var name = name.split(''/'');
          var options = options || {};
          var type = "GET";
          var data= null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_design/" + name[0] +
                   "/_view/" + name[1] + encodeOptions(options)
            },
            options, "An error occurred accessing the view"
          );
        },

        /**
         * Fetch an arbitrary CouchDB database property
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api.html">docs for /db/_prop</a>
         * @param {String} propName Propery name to fetch
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        getDbProperty: function(propName, options, ajaxOptions) {
          ajax({url: this.uri + propName + encodeOptions(options)},
            options,
            "The property could not be retrieved",
            ajaxOptions
          );
        },

        /**
         * Set an arbitrary CouchDB database property
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api.html">docs for /db/_prop</a>
         * @param {String} propName Propery name to fetch
         * @param {String} propValue Propery value to set
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        setDbProperty: function(propName, propValue, options, ajaxOptions) {
          ajax({
            type: "PUT", 
            url: this.uri + propName + encodeOptions(options),
            data : JSON.stringify(propValue)
          },
            options,
            "The property could not be updated",
            ajaxOptions
          );
        }
      };
    },

    encodeDocId: encodeDocId, 

    /**
     * Accessing the root of a CouchDB instance returns meta information about
     * the instance. The response is a JSON structure containing information
     * about the server, including a welcome message and the version of the
     * server.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_root_get">
     * docs for GET /</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/
     * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    info: function(options) {
      ajax(
        {url: this.urlPrefix + "/"},
        options,
        "Server information could not be retrieved"
      );
    },

    /**
     * Request, configure, or stop, a replication operation.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/
     * uploads/all/documentation/couchbase-api-misc.html#couchbase-api-
     * misc_replicate_post">docs for POST /_replicate</a>
     * @param {String} source Path or url to source database
     * @param {String} target Path or url to target database
     * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
     * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
     * @param {Object} repOpts Additional replication options
     */
    replicate: function(source, target, ajaxOptions, repOpts) {
      repOpts = $.extend({source: source, target: target}, repOpts);
      if (repOpts.continuous && !!repOpts.cancel) {
        ajaxOptions.successStatus = 202;
      }
      ajax({
          type: "POST", url: this.urlPrefix + "/_replicate",
          data: JSON.stringify(repOpts),
          contentType: "application/json"
        },
        ajaxOptions,
        "Replication failed"
      );
    },

    /**
     * Fetch a new UUID
     * @see <a href="http://techzone.couchbase.com/sites/default/files/
     * uploads/all/documentation/couchbase-api-misc.html#couchbase-api-
     * misc_uuids_get">docs for /_uuids</a>
     * @param {Int} cacheNum Number of uuids to keep cached for future use
     */
    newUUID: function(cacheNum) {
      if (cacheNum === undefined) {
        cacheNum = 1;
      }
      if (!!uuidCache.length) {
        ajax({url: this.urlPrefix + "/_uuids", data: {count: cacheNum}, async:
              false}, {
            success: function(resp) {
              uuidCache = resp.uuids;
            }
          },
          "Failed to retrieve UUID batch."
        );
      }
      return uuidCache.shift();
    }
  });

  /**
   * @private
   */
  function ajax(obj, options, errorMessage, ajaxOptions) {

    var defaultAjaxOpts = {
      contentType: "application/json",
      headers:{"Accept": "application/json"}
    };

    options = $.extend({successStatus: 200}, options);
    ajaxOptions = $.extend(defaultAjaxOpts, ajaxOptions);
    errorMessage = errorMessage || "Unknown error";
    $.ajax($.extend($.extend({
      type: "GET", dataType: "json", cache : !!$.browser.msie,
      beforeSend: function(xhr){
        if(ajaxOptions && ajaxOptions.headers){
          for (var header in ajaxOptions.headers){
            xhr.setRequestHeader(header, ajaxOptions.headers[header]);
          }
        }
      },
      complete: function(req) {
        try {
          var resp = $.parseJSON(req.responseText);
        } catch(e) {
          if (options.error) {
            options.error(req.status, req, e);
          } else {
            throw errorMessage + '': '' + e;
          }
          return;
        }
        if (options.ajaxStart) {
          options.ajaxStart(resp);
        }
        if (req.status == options.successStatus) {
          if (options.beforeSuccess) options.beforeSuccess(req, resp);
          if (options.success) options.success(resp);
        } else if (options.error) {
          options.error(req.status, resp && resp.error ||
                        errorMessage, resp && resp.reason || "no response");
        } else {
          throw errorMessage + ": " + resp.reason;
        }
      }
    }, obj), ajaxOptions));
  }

  /**
   * @private
   */
  function fullCommit(options) {
    var options = options || {};
    if (typeof options.ensure_full_commit !!== "undefined") {
      var commit = options.ensure_full_commit;
      delete options.ensure_full_commit;
      return function(xhr) {
        xhr.setRequestHeader(''Accept'', ''application/json'');
        xhr.setRequestHeader("X-Couch-Full-Commit", commit.toString());
      };
    }
  };

  /**
   * @private
   */
  // Convert a options object to an url query string.
  // ex: {key:''value'',key2:''value2''} becomes ''?key="value"&key2="value2"''
  function encodeOptions(options) {
    var buf = [];
    if (typeof(options) === "object" && options !!== null) {
      for (var name in options) {
        if ($.inArray(name,
                      ["error", "success", "beforeSuccess", "ajaxStart"]) >= 0)
          continue;
        var value = options[name];
        if ($.inArray(name, ["key", "startkey", "endkey"]) >= 0) {
          value = toJSON(value);
        }
        buf.push(encodeURIComponent(name) + "=" + encodeURIComponent(value));
      }
    }
    return buf.length ? "?" + buf.join("&") : "";
  }

  /**
   * @private
   */
  function toJSON(obj) {
    return obj !!== null ? JSON.stringify(obj) : null;
  }

})(jQuery);
'! !

!JQCouchDBDevelopmentLibrary methodsFor: 'uploaded' stamp: 'JesusMari 2/12/2013 12:13'!
jqueryformJs
	^ '/*!!
 * jQuery Form Plugin
 * version: 2.63 (29-JAN-2011)
 * @requires jQuery v1.3.2 or later
 *
 * Examples and documentation at: http://malsup.com/jquery/form/
 * Dual licensed under the MIT and GPL licenses:
 *   http://www.opensource.org/licenses/mit-license.php
 *   http://www.gnu.org/licenses/gpl.html
 */
;(function($) {

/*
	Usage Note:
	-----------
	Do not use both ajaxSubmit and ajaxForm on the same form.  These
	functions are intended to be exclusive.  Use ajaxSubmit if you want
	to bind your own submit handler to the form.  For example,

	$(document).ready(function() {
		$(''#myForm'').bind(''submit'', function(e) {
			e.preventDefault(); // <-- important
			$(this).ajaxSubmit({
				target: ''#output''
			});
		});
	});

	Use ajaxForm when you want the plugin to manage all the event binding
	for you.  For example,

	$(document).ready(function() {
		$(''#myForm'').ajaxForm({
			target: ''#output''
		});
	});

	When using ajaxForm, the ajaxSubmit function will be invoked for you
	at the appropriate time.
*/

/**
 * ajaxSubmit() provides a mechanism for immediately submitting
 * an HTML form using AJAX.
 */
$.fn.ajaxSubmit = function(options) {
	// fast fail if nothing selected (http://dev.jquery.com/ticket/2752)
	if (!!this.length) {
		log(''ajaxSubmit: skipping submit process - no element selected'');
		return this;
	}

	if (typeof options == ''function'') {
		options = { success: options };
	}

	var action = this.attr(''action'');
	var url = (typeof action === ''string'') ? $.trim(action) : '''';
	if (url) {
		// clean url (don''t include hash vaue)
		url = (url.match(/^([^#]+)/)||[])[1];
	}
	url = url || window.location.href || '''';

	options = $.extend(true, {
		url:  url,
		type: this[0].getAttribute(''method'') || ''GET'', // IE7 massage (see issue 57)
		iframeSrc: /^https/i.test(window.location.href || '''') ? ''javascript:false'' : ''about:blank''
	}, options);

	// hook for manipulating the form data before it is extracted;
	// convenient for use with rich editors like tinyMCE or FCKEditor
	var veto = {};
	this.trigger(''form-pre-serialize'', [this, options, veto]);
	if (veto.veto) {
		log(''ajaxSubmit: submit vetoed via form-pre-serialize trigger'');
		return this;
	}

	// provide opportunity to alter form data before it is serialized
	if (options.beforeSerialize && options.beforeSerialize(this, options) === false) {
		log(''ajaxSubmit: submit aborted via beforeSerialize callback'');
		return this;
	}

	var n,v,a = this.formToArray(options.semantic);
	if (options.data) {
		options.extraData = options.data;
		for (n in options.data) {
			if(options.data[n] instanceof Array) {
				for (var k in options.data[n]) {
					a.push( { name: n, value: options.data[n][k] } );
				}
			}
			else {
				v = options.data[n];
				v = $.isFunction(v) ? v() : v; // if value is fn, invoke it
				a.push( { name: n, value: v } );
			}
		}
	}

	// give pre-submit callback an opportunity to abort the submit
	if (options.beforeSubmit && options.beforeSubmit(a, this, options) === false) {
		log(''ajaxSubmit: submit aborted via beforeSubmit callback'');
		return this;
	}

	// fire vetoable ''validate'' event
	this.trigger(''form-submit-validate'', [a, this, options, veto]);
	if (veto.veto) {
		log(''ajaxSubmit: submit vetoed via form-submit-validate trigger'');
		return this;
	}

	var q = $.param(a);

	if (options.type.toUpperCase() == ''GET'') {
		options.url += (options.url.indexOf(''?'') >= 0 ? ''&'' : ''?'') + q;
		options.data = null;  // data is null for ''get''
	}
	else {
		options.data = q; // data is the query string for ''post''
	}

	var $form = this, callbacks = [];
	if (options.resetForm) {
		callbacks.push(function() { $form.resetForm(); });
	}
	if (options.clearForm) {
		callbacks.push(function() { $form.clearForm(); });
	}

	// perform a load on the target only if dataType is not provided
	if (!!options.dataType && options.target) {
		var oldSuccess = options.success || function(){};
		callbacks.push(function(data) {
			var fn = options.replaceTarget ? ''replaceWith'' : ''html'';
			$(options.target)[fn](data).each(oldSuccess, arguments);
		});
	}
	else if (options.success) {
		callbacks.push(options.success);
	}

	options.success = function(data, status, xhr) { // jQuery 1.4+ passes xhr as 3rd arg
		var context = options.context || options;   // jQuery 1.4+ supports scope context 
		for (var i=0, max=callbacks.length; i < max; i++) {
			callbacks[i].apply(context, [data, status, xhr || $form, $form]);
		}
	};

	// are there files to upload?
	var fileInputs = $(''input:file'', this).length > 0;
	var mp = ''multipart/form-data'';
	var multipart = ($form.attr(''enctype'') == mp || $form.attr(''encoding'') == mp);

	// options.iframe allows user to force iframe mode
	// 06-NOV-09: now defaulting to iframe mode if file input is detected
   if (options.iframe !!== false && (fileInputs || options.iframe || multipart)) {
	   // hack to fix Safari hang (thanks to Tim Molendijk for this)
	   // see:  http://groups.google.com/group/jquery-dev/browse_thread/thread/36395b7ab510dd5d
	   if (options.closeKeepAlive) {
		   $.get(options.closeKeepAlive, fileUpload);
		}
	   else {
		   fileUpload();
		}
   }
   else {
		$.ajax(options);
   }

	// fire ''notify'' event
	this.trigger(''form-submit-notify'', [this, options]);
	return this;


	// private function for handling file uploads (hat tip to YAHOO!!)
	function fileUpload() {
		var form = $form[0];

		if ($('':input[name=submit],:input[id=submit]'', form).length) {
			// if there is an input with a name or id of ''submit'' then we won''t be
			// able to invoke the submit fn on the form (at least not x-browser)
			alert(''Error: Form elements must not have name or id of "submit".'');
			return;
		}
		
		var s = $.extend(true, {}, $.ajaxSettings, options);
		s.context = s.context || s;
		var id = ''jqFormIO'' + (new Date().getTime()), fn = ''_''+id;
		var $io = $(''<iframe id="'' + id + ''" name="'' + id + ''" src="''+ s.iframeSrc +''" />'');
		var io = $io[0];

		$io.css({ position: ''absolute'', top: ''-1000px'', left: ''-1000px'' });

		var xhr = { // mock object
			aborted: 0,
			responseText: null,
			responseXML: null,
			status: 0,
			statusText: ''n/a'',
			getAllResponseHeaders: function() {},
			getResponseHeader: function() {},
			setRequestHeader: function() {},
			abort: function() {
				this.aborted = 1;
				$io.attr(''src'', s.iframeSrc); // abort op in progress
			}
		};

		var g = s.global;
		// trigger ajax global events so that activity/block indicators work like normal
		if (g && !! $.active++) {
			$.event.trigger("ajaxStart");
		}
		if (g) {
			$.event.trigger("ajaxSend", [xhr, s]);
		}

		if (s.beforeSend && s.beforeSend.call(s.context, xhr, s) === false) {
			if (s.global) { 
				$.active--;
			}
			return;
		}
		if (xhr.aborted) {
			return;
		}

		var timedOut = 0;

		// add submitting element to data if we know it
		var sub = form.clk;
		if (sub) {
			var n = sub.name;
			if (n && !!sub.disabled) {
				s.extraData = s.extraData || {};
				s.extraData[n] = sub.value;
				if (sub.type == "image") {
					s.extraData[n+''.x''] = form.clk_x;
					s.extraData[n+''.y''] = form.clk_y;
				}
			}
		}

		// take a breath so that pending repaints get some cpu time before the upload starts
		function doSubmit() {
			// make sure form attrs are set
			var t = $form.attr(''target''), a = $form.attr(''action'');

			// update form attrs in IE friendly way
			form.setAttribute(''target'',id);
			if (form.getAttribute(''method'') !!= ''POST'') {
				form.setAttribute(''method'', ''POST'');
			}
			if (form.getAttribute(''action'') !!= s.url) {
				form.setAttribute(''action'', s.url);
			}

			// ie borks in some cases when setting encoding
			if (!! s.skipEncodingOverride) {
				$form.attr({
					encoding: ''multipart/form-data'',
					enctype:  ''multipart/form-data''
				});
			}

			// support timout
			if (s.timeout) {
				setTimeout(function() { timedOut = true; cb(); }, s.timeout);
			}

			// add "extra" data to form if provided in options
			var extraInputs = [];
			try {
				if (s.extraData) {
					for (var n in s.extraData) {
						extraInputs.push(
							$(''<input type="hidden" name="''+n+''" value="''+s.extraData[n]+''" />'')
								.appendTo(form)[0]);
					}
				}

				// add iframe to doc and submit the form
				$io.appendTo(''body'');
                io.attachEvent ? io.attachEvent(''onload'', cb) : io.addEventListener(''load'', cb, false);
				form.submit();
			}
			finally {
				// reset attrs and remove "extra" input elements
				form.setAttribute(''action'',a);
				if(t) {
					form.setAttribute(''target'', t);
				} else {
					$form.removeAttr(''target'');
				}
				$(extraInputs).remove();
			}
		}

		if (s.forceSync) {
			doSubmit();
		}
		else {
			setTimeout(doSubmit, 10); // this lets dom updates render
		}
	
		var data, doc, domCheckCount = 50;

		function cb() {
			doc = io.contentWindow ? io.contentWindow.document : io.contentDocument ? io.contentDocument : io.document;
			if (!!doc || doc.location.href == s.iframeSrc) {
				// response not received yet
				return;
			}
            io.detachEvent ? io.detachEvent(''onload'', cb) : io.removeEventListener(''load'', cb, false);

			var ok = true;
			try {
				if (timedOut) {
					throw ''timeout'';
				}

				var isXml = s.dataType == ''xml'' || doc.XMLDocument || $.isXMLDoc(doc);
				log(''isXml=''+isXml);
				if (!!isXml && window.opera && (doc.body == null || doc.body.innerHTML == '''')) {
					if (--domCheckCount) {
						// in some browsers (Opera) the iframe DOM is not always traversable when
						// the onload callback fires, so we loop a bit to accommodate
						log(''requeing onLoad callback, DOM not available'');
						setTimeout(cb, 250);
						return;
					}
					// let this fall through because server response could be an empty document
					//log(''Could not access iframe DOM after mutiple tries.'');
					//throw ''DOMException: not available'';
				}

				//log(''response detected'');
				xhr.responseText = doc.body ? doc.body.innerHTML : doc.documentElement ? doc.documentElement.innerHTML : null; 
				xhr.responseXML = doc.XMLDocument ? doc.XMLDocument : doc;
				xhr.getResponseHeader = function(header){
					var headers = {''content-type'': s.dataType};
					return headers[header];
				};

				var scr = /(json|script)/.test(s.dataType);
				if (scr || s.textarea) {
					// see if user embedded response in textarea
					var ta = doc.getElementsByTagName(''textarea'')[0];
					if (ta) {
						xhr.responseText = ta.value;
					}
					else if (scr) {
						// account for browsers injecting pre around json response
						var pre = doc.getElementsByTagName(''pre'')[0];
						var b = doc.getElementsByTagName(''body'')[0];
						if (pre) {
							xhr.responseText = pre.textContent;
						}
						else if (b) {
							xhr.responseText = b.innerHTML;
						}
					}			  
				}
				else if (s.dataType == ''xml'' && !!xhr.responseXML && xhr.responseText !!= null) {
					xhr.responseXML = toXml(xhr.responseText);
				}
				
				data = httpData(xhr, s.dataType, s);
			}
			catch(e){
				log(''error caught:'',e);
				ok = false;
				xhr.error = e;
				s.error.call(s.context, xhr, ''error'', e);
				g && $.event.trigger("ajaxError", [xhr, s, e]);
			}
			
			if (xhr.aborted) {
				log(''upload aborted'');
				ok = false;
			}

			// ordering of these callbacks/triggers is odd, but that''s how $.ajax does it
			if (ok) {
				s.success.call(s.context, data, ''success'', xhr);
				g && $.event.trigger("ajaxSuccess", [xhr, s]);
			}
			
			g && $.event.trigger("ajaxComplete", [xhr, s]);

			if (g && !! --$.active) {
				$.event.trigger("ajaxStop");
			}
			
			s.complete && s.complete.call(s.context, xhr, ok ? ''success'' : ''error'');

			// clean up
			setTimeout(function() {
				$io.removeData(''form-plugin-onload'');
				$io.remove();
				xhr.responseXML = null;
			}, 100);
		}

		var toXml = $.parseXML || function(s, doc) { // use parseXML if available (jQuery 1.5+)
			if (window.ActiveXObject) {
				doc = new ActiveXObject(''Microsoft.XMLDOM'');
				doc.async = ''false'';
				doc.loadXML(s);
			}
			else {
				doc = (new DOMParser()).parseFromString(s, ''text/xml'');
			}
			return (doc && doc.documentElement && doc.documentElement.nodeName !!= ''parsererror'') ? doc : null;
		};
		var parseJSON = $.parseJSON || function(s) {
			return window[''eval''](''('' + s + '')'');
		};
		
		var httpData = function( xhr, type, s ) { // mostly lifted from jq1.4.4
			var ct = xhr.getResponseHeader(''content-type'') || '''',
				xml = type === ''xml'' || !!type && ct.indexOf(''xml'') >= 0,
				data = xml ? xhr.responseXML : xhr.responseText;

			if (xml && data.documentElement.nodeName === ''parsererror'') {
				$.error && $.error(''parsererror'');
			}
			if (s && s.dataFilter) {
				data = s.dataFilter(data, type);
			}
			if (typeof data === ''string'') {
				if (type === ''json'' || !!type && ct.indexOf(''json'') >= 0) {
					data = parseJSON(data);
				} else if (type === "script" || !!type && ct.indexOf("javascript") >= 0) {
					$.globalEval(data);
				}
			}
			return data;
		};
	}
};

/**
 * ajaxForm() provides a mechanism for fully automating form submission.
 *
 * The advantages of using this method instead of ajaxSubmit() are:
 *
 * 1: This method will include coordinates for <input type="image" /> elements (if the element
 *	is used to submit the form).
 * 2. This method will include the submit element''s name/value data (for the element that was
 *	used to submit the form).
 * 3. This method binds the submit() method to the form for you.
 *
 * The options argument for ajaxForm works exactly as it does for ajaxSubmit.  ajaxForm merely
 * passes the options argument along after properly binding events for submit elements and
 * the form itself.
 */
$.fn.ajaxForm = function(options) {
	// in jQuery 1.3+ we can fix mistakes with the ready state
	if (this.length === 0) {
		var o = { s: this.selector, c: this.context };
		if (!!$.isReady && o.s) {
			log(''DOM not ready, queuing ajaxForm'');
			$(function() {
				$(o.s,o.c).ajaxForm(options);
			});
			return this;
		}
		// is your DOM ready?  http://docs.jquery.com/Tutorials:Introducing_$(document).ready()
		log(''terminating; zero elements found by selector'' + ($.isReady ? '''' : '' (DOM not ready)''));
		return this;
	}
	
	return this.ajaxFormUnbind().bind(''submit.form-plugin'', function(e) {
		if (!!e.isDefaultPrevented()) { // if event has been canceled, don''t proceed
			e.preventDefault();
			$(this).ajaxSubmit(options);
		}
	}).bind(''click.form-plugin'', function(e) {
		var target = e.target;
		var $el = $(target);
		if (!!($el.is(":submit,input:image"))) {
			// is this a child element of the submit el?  (ex: a span within a button)
			var t = $el.closest('':submit'');
			if (t.length == 0) {
				return;
			}
			target = t[0];
		}
		var form = this;
		form.clk = target;
		if (target.type == ''image'') {
			if (e.offsetX !!= undefined) {
				form.clk_x = e.offsetX;
				form.clk_y = e.offsetY;
			} else if (typeof $.fn.offset == ''function'') { // try to use dimensions plugin
				var offset = $el.offset();
				form.clk_x = e.pageX - offset.left;
				form.clk_y = e.pageY - offset.top;
			} else {
				form.clk_x = e.pageX - target.offsetLeft;
				form.clk_y = e.pageY - target.offsetTop;
			}
		}
		// clear form vars
		setTimeout(function() { form.clk = form.clk_x = form.clk_y = null; }, 100);
	});
};

// ajaxFormUnbind unbinds the event handlers that were bound by ajaxForm
$.fn.ajaxFormUnbind = function() {
	return this.unbind(''submit.form-plugin click.form-plugin'');
};

/**
 * formToArray() gathers form element data into an array of objects that can
 * be passed to any of the following ajax functions: $.get, $.post, or load.
 * Each object in the array has both a ''name'' and ''value'' property.  An example of
 * an array for a simple login form might be:
 *
 * [ { name: ''username'', value: ''jresig'' }, { name: ''password'', value: ''secret'' } ]
 *
 * It is this array that is passed to pre-submit callback functions provided to the
 * ajaxSubmit() and ajaxForm() methods.
 */
$.fn.formToArray = function(semantic) {
	var a = [];
	if (this.length === 0) {
		return a;
	}

	var form = this[0];
	var els = semantic ? form.getElementsByTagName(''*'') : form.elements;
	if (!!els) {
		return a;
	}
	
	var i,j,n,v,el,max,jmax;
	for(i=0, max=els.length; i < max; i++) {
		el = els[i];
		n = el.name;
		if (!!n) {
			continue;
		}

		if (semantic && form.clk && el.type == "image") {
			// handle image inputs on the fly when semantic == true
			if(!!el.disabled && form.clk == el) {
				a.push({name: n, value: $(el).val()});
				a.push({name: n+''.x'', value: form.clk_x}, {name: n+''.y'', value: form.clk_y});
			}
			continue;
		}

		v = $.fieldValue(el, true);
		if (v && v.constructor == Array) {
			for(j=0, jmax=v.length; j < jmax; j++) {
				a.push({name: n, value: v[j]});
			}
		}
		else if (v !!== null && typeof v !!= ''undefined'') {
			a.push({name: n, value: v});
		}
	}

	if (!!semantic && form.clk) {
		// input type==''image'' are not found in elements array!! handle it here
		var $input = $(form.clk), input = $input[0];
		n = input.name;
		if (n && !!input.disabled && input.type == ''image'') {
			a.push({name: n, value: $input.val()});
			a.push({name: n+''.x'', value: form.clk_x}, {name: n+''.y'', value: form.clk_y});
		}
	}
	return a;
};

/**
 * Serializes form data into a ''submittable'' string. This method will return a string
 * in the format: name1=value1&amp;name2=value2
 */
$.fn.formSerialize = function(semantic) {
	//hand off to jQuery.param for proper encoding
	return $.param(this.formToArray(semantic));
};

/**
 * Serializes all field elements in the jQuery object into a query string.
 * This method will return a string in the format: name1=value1&amp;name2=value2
 */
$.fn.fieldSerialize = function(successful) {
	var a = [];
	this.each(function() {
		var n = this.name;
		if (!!n) {
			return;
		}
		var v = $.fieldValue(this, successful);
		if (v && v.constructor == Array) {
			for (var i=0,max=v.length; i < max; i++) {
				a.push({name: n, value: v[i]});
			}
		}
		else if (v !!== null && typeof v !!= ''undefined'') {
			a.push({name: this.name, value: v});
		}
	});
	//hand off to jQuery.param for proper encoding
	return $.param(a);
};

/**
 * Returns the value(s) of the element in the matched set.  For example, consider the following form:
 *
 *  <form><fieldset>
 *	  <input name="A" type="text" />
 *	  <input name="A" type="text" />
 *	  <input name="B" type="checkbox" value="B1" />
 *	  <input name="B" type="checkbox" value="B2"/>
 *	  <input name="C" type="radio" value="C1" />
 *	  <input name="C" type="radio" value="C2" />
 *  </fieldset></form>
 *
 *  var v = $('':text'').fieldValue();
 *  // if no values are entered into the text inputs
 *  v == ['''','''']
 *  // if values entered into the text inputs are ''foo'' and ''bar''
 *  v == [''foo'',''bar'']
 *
 *  var v = $('':checkbox'').fieldValue();
 *  // if neither checkbox is checked
 *  v === undefined
 *  // if both checkboxes are checked
 *  v == [''B1'', ''B2'']
 *
 *  var v = $('':radio'').fieldValue();
 *  // if neither radio is checked
 *  v === undefined
 *  // if first radio is checked
 *  v == [''C1'']
 *
 * The successful argument controls whether or not the field element must be ''successful''
 * (per http://www.w3.org/TR/html4/interact/forms.html#successful-controls).
 * The default value of the successful argument is true.  If this value is false the value(s)
 * for each element is returned.
 *
 * Note: This method *always* returns an array.  If no valid value can be determined the
 *	   array will be empty, otherwise it will contain one or more values.
 */
$.fn.fieldValue = function(successful) {
	for (var val=[], i=0, max=this.length; i < max; i++) {
		var el = this[i];
		var v = $.fieldValue(el, successful);
		if (v === null || typeof v == ''undefined'' || (v.constructor == Array && !!v.length)) {
			continue;
		}
		v.constructor == Array ? $.merge(val, v) : val.push(v);
	}
	return val;
};

/**
 * Returns the value of the field element.
 */
$.fieldValue = function(el, successful) {
	var n = el.name, t = el.type, tag = el.tagName.toLowerCase();
	if (successful === undefined) {
		successful = true;
	}

	if (successful && (!!n || el.disabled || t == ''reset'' || t == ''button'' ||
		(t == ''checkbox'' || t == ''radio'') && !!el.checked ||
		(t == ''submit'' || t == ''image'') && el.form && el.form.clk !!= el ||
		tag == ''select'' && el.selectedIndex == -1)) {
			return null;
	}

	if (tag == ''select'') {
		var index = el.selectedIndex;
		if (index < 0) {
			return null;
		}
		var a = [], ops = el.options;
		var one = (t == ''select-one'');
		var max = (one ? index+1 : ops.length);
		for(var i=(one ? index : 0); i < max; i++) {
			var op = ops[i];
			if (op.selected) {
				var v = op.value;
				if (!!v) { // extra pain for IE...
					v = (op.attributes && op.attributes[''value''] && !!(op.attributes[''value''].specified)) ? op.text : op.value;
				}
				if (one) {
					return v;
				}
				a.push(v);
			}
		}
		return a;
	}
	return $(el).val();
};

/**
 * Clears the form data.  Takes the following actions on the form''s input fields:
 *  - input text fields will have their ''value'' property set to the empty string
 *  - select elements will have their ''selectedIndex'' property set to -1
 *  - checkbox and radio inputs will have their ''checked'' property set to false
 *  - inputs of type submit, button, reset, and hidden will *not* be effected
 *  - button elements will *not* be effected
 */
$.fn.clearForm = function() {
	return this.each(function() {
		$(''input,select,textarea'', this).clearFields();
	});
};

/**
 * Clears the selected form elements.
 */
$.fn.clearFields = $.fn.clearInputs = function() {
	return this.each(function() {
		var t = this.type, tag = this.tagName.toLowerCase();
		if (t == ''text'' || t == ''password'' || tag == ''textarea'') {
			this.value = '''';
		}
		else if (t == ''checkbox'' || t == ''radio'') {
			this.checked = false;
		}
		else if (tag == ''select'') {
			this.selectedIndex = -1;
		}
	});
};

/**
 * Resets the form data.  Causes all form elements to be reset to their original value.
 */
$.fn.resetForm = function() {
	return this.each(function() {
		// guard against an input with the name of ''reset''
		// note that IE reports the reset function as an ''object''
		if (typeof this.reset == ''function'' || (typeof this.reset == ''object'' && !!this.reset.nodeType)) {
			this.reset();
		}
	});
};

/**
 * Enables or disables any matching elements.
 */
$.fn.enable = function(b) {
	if (b === undefined) {
		b = true;
	}
	return this.each(function() {
		this.disabled = !!b;
	});
};

/**
 * Checks/unchecks any matching checkboxes or radio buttons and
 * selects/deselects and matching option elements.
 */
$.fn.selected = function(select) {
	if (select === undefined) {
		select = true;
	}
	return this.each(function() {
		var t = this.type;
		if (t == ''checkbox'' || t == ''radio'') {
			this.checked = select;
		}
		else if (this.tagName.toLowerCase() == ''option'') {
			var $sel = $(this).parent(''select'');
			if (select && $sel[0] && $sel[0].type == ''select-one'') {
				// deselect all other options
				$sel.find(''option'').selected(false);
			}
			this.selected = select;
		}
	});
};

// helper fn for console logging
// set $.fn.ajaxSubmit.debug to true to enable debug logging
function log() {
	if ($.fn.ajaxSubmit.debug) {
		var msg = ''[jquery.form] '' + Array.prototype.join.call(arguments,'''');
		if (window.console && window.console.log) {
			window.console.log(msg);
		}
		else if (window.opera && window.opera.postError) {
			window.opera.postError(msg);
		}
	}
};

})(jQuery);
'! !

!JQCouchDBDevelopmentLibrary methodsFor: 'accessing' stamp: 'JesusMari 2/14/2013 13:48'!
selectorsToInclude
	^ #(jquerycouchJs jqueryformJs jqueryattachementsHandlingJs)! !

WAFileLibrary subclass: #JQCouchDBJQueryLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Lib'!

!JQCouchDBJQueryLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/3/2013 00:30'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript
		url: 'http://127.0.0.1:5984/_utils/script/jquery.js'! !

WAFileLibrary subclass: #JQCouchDBLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Lib'!

!JQCouchDBLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/12/2013 12:16'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript
		url: 'http://127.0.0.1:5984/_utils/script/jquery.couch.js'.
	anHtmlRoot javascript
		url:'http://127.0.0.1:5984/_utils/script/jquery.form.js'! !

WAComponent subclass: #JQAlbumDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional-mobile'!

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/12/2013 00:32'!
renderAlbumRemoveScriptOn:html
| aScript |

"we need the _revision"
aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: '_id' put:((html jQuery:#dataStorage) dataAt:#currentDoc);
	at: '_rev' put:((html jQuery:#dataStorage) dataAt:#currentRev);yourself
)). 
	
html document addLoadScript: 
((html jQuery:#deleteOkButton) onClick:(
(html jQuery couch db:'albums';removeDoc: aScript;
					onSuccess:(html jQuery mobile changePageUrl:  '/_seaside/albums' options:nil);
					onError:(( html jQuery:#fHeader) text:'Error deleting a Doc')
)))! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:08'!
renderContentOn:html
	self renderDeleteAlbumHeaderOn:html.
 	self renderDeleteAlbumContentOn:html.
   	self renderDeleteAlbumFooterOn:html.
	self renderAlbumRemoveScriptOn:html! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:08'!
renderDeleteAlbumContentOn:html
  html div
      jqmContent;
      with: [
	html heading level3 with:'Are you sure you want to remove this album?']
	! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:12'!
renderDeleteAlbumFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;	
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor
								jqmIcon: 'minus';
								id:#deleteOkButton;
								with: 'Ok' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							jqmIcon: 'gear';
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel'.
							] ] ].

] ! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:12'!
renderDeleteAlbumHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
		id:#fHeader;
            with: 'Delete Album']! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:09'!
renderLoginHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
            with: 'Delete Album']! !

WAComponent subclass: #JQAlbumEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional-mobile'!

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 09:45'!
json
	^ JSJson new! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:32'!
loadSkeletonOn:html
	html div
      		jqmHeader;
      		with:  [	  
				   html heading
					id:#eHeader;
    			   	   level1;
      			   with:''.
				
				html anchor
           			 	class: 'ui-btn-right';
            			jqmIcon: 'home';
					url:'#pageId1';
            			with: 'Home' ].
	html div
			id:#eContent;
      		jqmContent;
      		with: ''.
	self renderAlbumEditorFooterOn:html.
	self renderAttachmentsOn:html! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:16'!
renderAlbumEditorContentOn:html


			html div jqmContainerTwoColumn; with: [
			html div jqmColumnOne; with: [
			html form id:#saveForm;post;with:[				
				self renderFormElementOn:html element:[
				html label
					for:#artist;
					with:'Artist:'.
				html textInput id:#artist;name:#artist;value:(html mustache variable:'artist').
				].
				self renderFormElementOn:html element:[
				html label
					for:#title;
					with:'Title:'.
				html textInput id:#title;name:#title;value:(html mustache variable:'title')].
				self renderFormElementOn:html element:[
				html label
					for:#description;
					with:'Description:'.
				html textInput id:#description;name:#description;value:(html mustache variable:'description')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#user;name:#user;value: (self session sessionData at:'name')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#id;name:#_id;value: (html mustache variable:'_id')].
				]
			].
			html div jqmColumnTwo; with: [
				html form id:#saveAttachmentForm;post;action:nil;multipart;with:[  
					html fileUpload id:#_attachments;name:#_attachments;multiple.  
					html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev').
				].
				html div id:#attachmentsContent. 
			]
			
		]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:23'!
renderAlbumEditorFooterOn:html

html div
			id:#eFooter;
      		jqmFooter;
			jqmFixedPosition;
      		with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'back';
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlidedown
							 	id:#saveButton;
								jqmIcon: 'gear';
								with: 'save' ].		
					
			
			]
		]
	]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 16:57'!
renderAlbumEditorHeaderOn:html


      html html:(html mustache variable:'title').! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/14/2013 10:00'!
renderAlbumSaveAttachmentOn:html
| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'at') assign:
	((GRSmallDictionary new) 
	at: 'url' put: 
		((JSStream on: '"/albums/"') call:'concat' 
				with: ((html jQuery:#id) value) 
		);
	at: 'success' put:((( html jQuery:#eHeader) text:'Attachment added') asFunction);yourself )
).

^
((( html jQuery:#eHeader) text:'Attachment go')),
aScript,
	(((( html jQuery:#eHeader) text:'start trans')),
	((html jQuery:#saveAttachmentForm) call:'ajaxSubmit' with: (JSStream on:'at')),
	((( html jQuery:#eHeader) text:'end trans'))) condition:((html jQuery:#_attachments) value )! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:36'!
renderAlbumSaveScriptOn:html

| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: 'artist' put:((html jQuery:#artist) value);
	at: 'title' put:((html jQuery:#title) value);
	at: 'user' put:((html jQuery:#user) value);
	at: '_id' put:((html jQuery:#id) value);
	at: '_rev' put:((html jQuery:#rev) value);
	at: 'description' put:((html jQuery:#description) value);
	at: '_attachments' put:(JSStream on:'attachments');yourself)). 

html document addLoadScript: (
(html jQuery:#saveButton) onClick:(
aScript,
"remove id and rev property if they were nul"
(((JSStream on: 'doc') property:'_id') not then: (JSStream on: 'delete doc._id')),
(((JSStream on: 'doc') property:'_rev') not then: (JSStream on: 'delete doc._rev')),
(html jQuery couch db:'albums';saveDoc: (JSStream on:'doc');
					onSuccess:(
								((html jQuery:'input[name="_rev"], form') each:( 
										html jQuery new value:(JSStream on:'doc._rev' ))) ,
								(( html jQuery:#eHeader) text:'Document saved'),
								(self renderAlbumSaveAttachmentOn:html),
								((JSStream on:'history')call:'back'));
					onError:(( html jQuery:#eHeader) text:'Error saving document'))
)
)! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:16'!
renderAlbumViewLoadScriptOn:html
"Loads a doc from CouchDb and renders Mustache templates"
html document addLoadScript:(
(html jQuery page onShow:(
   	html jQuery couch db:'albums';openDoc:((html jQuery:#dataStorage) 
											dataAt:#currentDoc);
					onSuccess:(
						"attachments global var stores temporally the doc attachments
						we need them to save them back"
						(((html jQuery event)access:'_attachments') assignTo:'attachments' ),
						(( html jQuery:#eContent) 
							mustache: (html jQuery:#aeContent) html
							data:(html jQuery event);
							trigger: 'create') ,
						(( html jQuery:#eHeader) 
							mustache: (html jQuery:#aeHeader) html
							data:html jQuery event
							command:'text'),
						"attachments are javascript dictionaries indexed by a filename, Mustache can not handle this kind of structure, it handles objects with well-know properties or arrays of objects "
						(( html jQuery:#attachmentsContent) 
							mustache: (html jQuery:#tAttachments) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)));
							trigger:'create')),
						(self renderAttachmentsDeleteOn: html);
					onError:(
						(( html jQuery:#eContent) 
							mustache: (html jQuery:#aeContent) html
							data:(html jQuery event);
							trigger: 'create') ,
						(( html jQuery:#eHeader) 
							text:'New Album'))
	))
)! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:21'!
renderAttachmentsDeleteOn:html
"register a delete attachment function on a click event for each element with the class .del (anchor in edit album) building an HTTP call:
DELETE /somedatabase/some_doc?rev=1582603387.
It must be registered after Mustache template is loaded"
^
(((html jQuery:'.del') each:((html jQuery new) onClick:(
					((((((html jQuery this) previous)previous) attributeAt:'src') call:'toString') assignLocalTo: 'aUrl'),
					(((JSStream on:'aUrl') call:'concat' with: '?rev=' with:(((html jQuery:#rev) value) call:'toString' )) assignLocalTo:'aU'),
					(html jQuery ajax 
							url: (JSStream on:'aU');
							type:'delete';
							onSuccess: ((JSStream on:'history') call:'back')
							
					)))))
			
	
! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 18:45'!
renderAttachmentsOn:html
html mustache template:'tAttachments';with:[
	html paragraph: 'Attachments:'.
	html mustache section 
		name:'_attachments';
		with:[
			html image class:'img';
				url: '/albums/',(html mustache variable:'_id') , 
					'/',
					(html mustache variable:'filename'). 
			html break.
			html anchor jqmButton;class:'del';
			with:'remove'.	
					
		]. 
	
]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 18:38'!
renderContentOn:html
self renderAlbumViewLoadScriptOn:html.	
self renderAlbumSaveScriptOn:html.
self renderAlbumSaveAttachmentOn:html.
self loadSkeletonOn:html.
html mustache template:'aeHeader';
	with:[self renderAlbumEditorHeaderOn:html].
html mustache template:'aeContent';
	with:[self renderAlbumEditorContentOn:html].
html mustache template:'aeFooter';
	with:[self renderAlbumEditorFooterOn:html].



! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 16:59'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

WAComponent subclass: #JQAlbumView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional-mobile'!

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 00:05'!
json
	^ JSJson new! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:22'!
loadSkeletonOn:html
"renders a mobile skeleton(the static content) page"
	html div
      		jqmHeader;
      		with:  [	  
				   html heading
					id:#bHeader;
    			   	   level1.
      			   "with:....will be filled by mustache"
				
				html anchor
           			 	class: 'ui-btn-right';
            			jqmIcon: 'home';
					jqmTransitionSlide; 
					url:'#pageId1';
            			with: 'Home' ].
	html div
			id:#bContent;
      		jqmContent.
		 	"with:....will be filled by mustache"
		
	self renderAlbumViewFooterOn:html.
	self renderAttachmentsOn:html! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:48'!
renderAlbumViewContentOn:html
"it is loaded as a mustache template"
		html div jqmContainerTwoColumn; with: [
			html div jqmColumnOne; with: [
				html heading
            			level1;
            			with:(html mustache variable:'artist').
				html paragraph:(html mustache variable:'title').
				html paragraph:(html mustache variable:'description').
				html paragraph:(html mustache variable:'user')].
			html div jqmColumnTwo; with: [
				html div id:#bAttachmentsContent.
				"with:...will be filled later by mustache"
									]
								
		]		
		
		! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:23'!
renderAlbumViewFooterOn:html

html div
			id:#dFooter;
      		jqmFooter;
			jqmFixedPosition;
      		with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'minus';
								jqmDialog;
								jqmTransitionFlip;
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumDelete new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Delete' ].
						html listItem: [
							html anchor jqmTransitionSlidedown
							 	id:#editButton;
								jqmIcon: 'gear';
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumEditor new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Edit' ].						
					] 
			]
]! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:42'!
renderAlbumViewHeaderOn:html
"this template only updates the text content of the html heading. We don't want to replace other tags because we want to preserve mobile classes"

      html html:(html mustache variable:'title').

	! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:47'!
renderAlbumViewLoadScriptOn:html
"loads an album document and fill the empty skeleton with mustache templates"
html document addLoadScript:(
html jQuery page onShow:(
   	html jQuery couch db:'albums';openDoc:((html jQuery:#dataStorage) 
											dataAt:#currentDoc);
					onSuccess:(
						(( html jQuery:#bContent) 
							mustache: (html jQuery:#avContent) html
							data:html jQuery event) ,
						(( html jQuery:#bHeader) 
							mustache: (html jQuery:#avHeader) html
							data:html jQuery event
							command:'text'),
						"Couchdb attachments need a transformation from jsscript dictionary 
						to an array of pair index->value, in order to be rendered in a mustache template
						attachmentsToArray is defined within development lib and is not present 
						if you don't use this lib"
						(( html jQuery:#bAttachmentsContent) 
							mustache: (html jQuery:#avAttachments) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)))));
					onError:((html jQuery:#aView)  html:'Error in connection')
		 
		)
	)
	! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:45'!
renderAttachmentsOn:html
html mustache template:'avAttachments';with:[
	html paragraph: 'Attachments:'.
	html mustache section 
		name:'_attachments';
		with:[
			html image
				url: '/albums/',(html mustache variable:'_id') , 
					'/',
					(html mustache variable:'filename') ]. 
	
]! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:34'!
renderContentOn:html
self renderAlbumViewLoadScriptOn:html.	
self loadSkeletonOn:html.
"render mustache templates"
html mustache template:'avHeader';
	with:[self renderAlbumViewHeaderOn:html].
html mustache template:'avContent';
	with:[self renderAlbumViewContentOn:html].
html mustache template:'avFooter';
	with:[self renderAlbumViewFooterOn:html].

	! !

WAComponent subclass: #JQAlbumsList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional-mobile'!

!JQAlbumsList class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/6/2013 23:00'!
canBeRoot
^true! !

!JQAlbumsList class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:28'!
register
JQMAdmin register: self asApplicationAt: 'albums'! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/6/2013 17:50'!
json
	^ JSJson new! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:21'!
renderAlbumListContentOn:html

		html div
      		jqmContent;
      		with: [	
				html unorderedList 
					id:#listContent;
      				jqmListView.
      				
			].
		
html mustache 
		template:#al;
		with:[		
			html mustache 
				section name:'rows';
				with:[  
           			html listItem
					with: [
      				html anchor
						id: (html mustache variable:'id');
						title: (html mustache variable:'value._rev');
						jqmTransitionSlide; 
						callback:[self show:JQAlbumView new];
           					with: [
							html mustache section 
								name:'_attachments';
								with:[
									html image
						 				url: '/albums/',(html mustache variable:'_id') , 
										'/',
										(html mustache variable:'filename') ].
							html heading level1; with:(html mustache variable:'value.artist').
							html paragraph: (html mustache variable:'value.description').   
							html paragraph: (html mustache variable:'value.title').   
                      			]  .
 	      			
  		      
		] ] ].

! !

!JQAlbumsList methodsFor: 'accessing' stamp: 'JesusMari 2/12/2013 00:51'!
renderAlbumListFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'plus';
								onClick:	((html jQuery:#dataStorage) 
											dataAt:#currentDoc 
											put:	nil);
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumEditor new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Add' ].
						html listItem: [
							html anchor jqmTransitionSlidedown	
								jqmIcon:'search';
								with: 'Search' 
							] 
					] 
			]
	] ! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:31'!
renderAlbumListHeaderOn:html
html div
	id:#dataStorage;
      jqmHeader;
      with: [
         html heading
            level1;
            with:       [	html span:'Albums'].
	 ].
! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/14/2013 18:15'!
renderAlbumListLoadScriptOn:html
"we have to declare the event callback after the list  was updated and before it was refreshed because jQuery mobile will wrap our anchor tag with a Div tag and the jquery sentence had to be div > a loosing sense"
html document addLoadScript:(
html jQuery page onShow:(
   	html jQuery couch db:'albums';view:'albums/albums';
					onSuccess:(( html jQuery:#listContent) 
							mustache: (html jQuery:#al) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)))
							command:'html'),
							((html jQuery:'li > a') onClick:(
										((html jQuery:#dataStorage) 
											dataAt:#currentDoc 
											put:	(html jQuery this attributeAt: 'id')),
										((html jQuery:#dataStorage) 
											dataAt:#currentRev 
											put:	(html jQuery this attributeAt: 'title')))),
							((html jQuery:#listContent) jqmListView refresh);
					onError:((html jQuery:#alist) html:'Error in connection')
		 
		)
)	! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:22'!
renderContentOn:html

	self renderAlbumListHeaderOn:html.
	self renderAlbumListContentOn:html.
	self renderAlbumListFooterOn:html.
	self renderAlbumListLoadScriptOn:html.
	
	! !

WAComponent subclass: #JQAlbumsLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional-mobile'!

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/12/2013 02:26'!
initialize
super initialize.

! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:22'!
json
	^ JSJson new
! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 21:32'!
renderContentOn:html
	self renderLoginHeaderOn:html.
 	self renderLoginContentOn:html.
   	self renderLoginFooterOn:html! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 11:03'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 19:05'!
renderLoginContentOn:html
  html div
      jqmContent;
      with: [
	html form: [
  
		self renderFormElementOn:html element: [
			html label
				for: #uName;
				with: 'UserName:'.
			html textInput
				id: #uName.
		].
	
		self renderFormElementOn:html element: [
     			 html label
         			for: #passw;
         			with: 'Password:'.
      		html passwordInput
         			id: #passw.
		].
	].	
].
 ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 19:20'!
renderLoginFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;	
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							onClick: (html jQuery ajax script:[:s | s<<(self renderLoginScriptOn:s)]);
							with: 'Submit' 
							] ] ].

] ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 11:21'!
renderLoginHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
            with:       [	html span:'CouchDB Status:'.
		html code id:#logger; with:'waiting for connection']].
   ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:27'!
renderLoginScriptOn:js
"password is sended in plain text, don't do that in a real app otherwise use https or cipher the password"
^(js jQuery couch login:((js jQuery:'#uName') value) password:((js jQuery:'#passw') value) ;
				onSuccess:(( js jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString),
							(js jQuery ajax callback:[:v|
								self session sessionData:(JSJsonParser parse: v)
								]
								value:(self json stringify:js jQuery event)),
								((JSStream on:'history') call:'back');
				onError:((js jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString)) 
! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:27'!
updateRoot:anHtmlRoot
"always as a dialog box"
anHtmlRoot pageDivAttributes at: 'data-role' put: 'dialog'! !

WAComponent subclass: #JQSCouchDBTest
	instanceVariableNames: 'textInput aCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional'!

!JQSCouchDBTest class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:12'!
canBeRoot
^true! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/1/2013 13:11'!
json
	^ JSJson new! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 20:23'!
renderContentOn:html
"self requestContext response headers at:'Access-Control-Allow-Origin' put:'"
html heading:'Demo CouchDB'.
self renderCouchInitOn:html.
self renderDocOn:html.
self renderTemplateOn:html! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:23'!
renderCouchInitOn:html
	html div with:[
		html span:'Status:'.
		html code id:#logger; with:'waiting for connection'.
		].
	html script:(
		html jQuery ready:(
			"don't do that in a real app"
			html jQuery couch login:'admin' password:'admin' ;
				onSuccess:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString]);
				onError:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString]))
		)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 11:00'!
renderCouchLoadViewOn:js 
"Server side style"
	^ js jQuery couch db:'test';allDocs;
		onSuccess: 
					((js jQuery:#serverSide) load 
							html:[:html|
								html paragraph:( aCollection at:'total_rows').
								aCollection
								ifNil:[html paragraph]
								 ifNotNil:[
									(aCollection at:'rows' ) do:[:i|
										 html paragraph:(i at:#id). 
									].
								]
							];
					callback:[:data|
						aCollection:= JSJsonParser parse: data.
						]	 
					value: (self json stringify: js jQuery event))! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:53'!
renderCouchLoadViewOnNew:js 
"client side style"
	^ js jQuery couch db:'test';allDocs;
		onSuccess: 
					((js jQuery:#clientSide)  
							mustache: (js jQuery:#test1) html
							data:(js jQuery event)
							command:'html'
							
					)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:54'!
renderCouchSaveDocOn:js content:aWord

	js << js jQuery couch db:'test';saveDoc: (JSStream on:'{"word":"', aWord,'"}');
				onSuccess: (
							(self renderCouchLoadViewOnNew: js),
							(self renderCouchLoadViewOn: js)
						).
	
	
		! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:57'!
renderDocOn:html
 self
      renderLabel: 'Text-Input'
      control: [ :id :script |
         html textInput
            id: id;
            value: textInput;
            callback: [ :value | textInput := value ];
            onChange: (script html: [ :h | h render: textInput ]).
         "the following code checks if a manual submit does a correct encoding:"
         html submitButton
            onClick: (html jQuery ajax
               callback: [ :value | textInput := value ] 
		   value: (html jQuery id: id) value;
               script: [ :s | 
				self renderCouchSaveDocOn: s content: textInput.
				]);
            with: 'Manual Submit'.
  	 ]
      model: textInput
      on: html.

	html table id:#dataList; with:[
		html tableData with:[
			html paragraph id:#clientSide
			].
		html tableData with:[
			html paragraph id:#serverSide 
	] 
].

! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:06'!
renderLabel: aString control: aBlock model: anObject on: html
   | id |
   html fieldSet: [
      html label
         for: (id := html nextId);
         with: aString.
      html span: [
         aBlock
            value: id
            " update the paragraph "
            value: ((html jQuery this	
               parents: 'fieldset';
               find: 'p') load
                  " serialize all nearby form elements "
                  serialize: (html jQuery this		
                     parents: 'span';
                     find: ':input')) ].
      html paragraph: anObject ]
! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:48'!
renderTemplateOn:html
html mustache
		template:'test1';
		with:[
			html paragraph:( html mustache variable:'total_rows').
			
				html mustache section 
						name:'rows';
						with:[ html paragraph:(html mustache variable:'id')]
			]
		! !

WASession subclass: #JQAlbumsSession
	instanceVariableNames: 'sessionData currentDoc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test-Functional-mobile'!

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 16:21'!
currentDoc
^ currentDoc
! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 15:50'!
currentDoc: docId
currentDoc:=docId
! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:32'!
initialize
super initialize.
sessionData:=nil! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:37'!
loggedIn
^self  sessionData notNil.! !

!JQAlbumsSession methodsFor: 'accessing' stamp: 'JesusMari 2/8/2013 18:28'!
sessionData
	^ sessionData! !

!JQAlbumsSession methodsFor: 'accessing' stamp: 'JesusMari 2/8/2013 18:28'!
sessionData: anObject
	sessionData := anObject! !

JSObjectTest subclass: #JQueryCouchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test'!

JQueryCouchTest subclass: #JQueryCouchDbTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test'!

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/30/2012 23:16'!
couch
	^ self jQuery couch! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 00:13'!
couchDb
	^ self jQuery couchDb! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/13/2013 00:30'!
test0Couch
	self
		assert: (self jQuery couch)
		equals: self function , '.couch'.
self
		assert: (self jQuery couch urlPrefix:'http://localhost:5984')
		equals: self function , '.couch.urlPrefix="http://localhost:5984"'.
		
	self
		assert: (self jQuery couch urlPrefix)
		equals: self function , '.couch.urlPrefix'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:58'!
test0Database

	self
		assert: (self jQuery couch db:'test';create)
		equals: self function , '.couch.db("test").create'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/13/2013 00:45'!
test0EncodeDocId

	self
		assert: (self jQuery couch encodeDocId:'test')
		equals: self function , '.couch.encodeDocId("test")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:58'!
test1Info

	self
		assert: (self jQuery couch info;onSuccess:'alert(data);')
		equals: self function , '.couch.info({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:04'!
test2allDbs

	self
		assert: (self jQuery couch allDbs)
		equals: self function , '.couch.allDbs'.
	self
		assert: (self jQuery couch allDbs;onSuccess:'alert(data);')
		equals: self function , '.couch.allDbs({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test3SignUp
|user|

	
	self
		assert: (self jQuery couch signUp:'bob' password:'superpassword')
		equals: self function , '.couch.signup({"_id":"org.couchdb.user:bob","name":"bob"},"superpassword")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test4Login


	
	self
		assert: (self jQuery couch login:'bob' password:'superpassword';onSuccess:'done')
		equals: self function , '.couch.login({"success":function(data){done},"password":"superpassword","name":"bob"})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test5session

	self
		assert: (self jQuery couch session;onSuccess:'alert(data);')
		equals: self function , '.couch.session({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test6logout

	self
		assert: (self jQuery couch logout;onSuccess:'alert(data);')
		equals: self function , '.couch.logout({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test7activeTasks

	self
		assert: (self jQuery couch activeTasks;onSuccess:'alert(data);')
		equals: self function , '.couch.activeTasks({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test8config

	self
		assert: (self jQuery couch config:'uuids'option:'algorithm';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm")'.
	self
		assert: (self jQuery couch config:'uuids'option:'algorithm'value:'sequential';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm","sequential")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test9userDb

	self
		assert: (self jQuery couch userDb:'alert(data);')
		equals: self function , '.couch.userDb(function(data){alert(data);})'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
testAnewUUID

	self
		assert: (self jQuery couch newUUID)
		equals: self function , '.couch.newUUID()'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
testBReplicateDatabase

	self
		assert: (self jQuery couch replicate:'DB' to:'NEWDB' createTarget:true;onSuccess:'done';onError:'error')
		equals: self function , '.couch.replicate("DB","NEWDB",{"success":function(data){done},"error":function(status){error}},{"create_target":true})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testCDatabaseCreate

	self
		assert: (self jQuery couch db:'test';create;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").create({"success":function(data){done},"error":function(status){error}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testDDatabaseInfo

	self
		assert: (self jQuery couch db:'test';info;onSuccess:'done')
		equals: self function , '.couch.db("test").info({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 21:52'!
testEsaveDoc

	self
		assert: (self jQuery couch db:'test';saveDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").saveDoc("aDoc",{"success":function(data){done},"error":function(status){error}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testFopenDoc

	self
		assert: (self jQuery couch db:'test';openDoc:'d12ee5ea1df6baa2b06451f44a019ab9';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").openDoc("d12ee5ea1df6baa2b06451f44a019ab9",{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testGremoveDoc

	self
		assert: (self jQuery couch db:'test';removeDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").removeDoc("aDoc",{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:49'!
testHbulkSave

|aDoc|
	aDoc:=GRSmallDictionary new.
	aDoc at:'docs' put: 'aDocument'.
	
	self
		assert: (self jQuery couch db:'test';bulkSave:(aDoc);onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkSave({"docs":"aDocument"},{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:51'!
testIbulkRemove

|aDoc|
	aDoc:=GRSmallDictionary new.
	aDoc at:'docs' put: 'aDocument'.
	self
		assert: (self jQuery couch db:'test';bulkRemove:aDoc;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkRemove({"docs":"aDocument"},{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testJallDocs

	self
		assert: (self jQuery couch db:'test';allDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDocs({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testKallDesignDocs

	self
		assert: (self jQuery couch db:'test';allDesignDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDesignDocs({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testKquery

	self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}})'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}})'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testLallApps

	self
		assert: (self jQuery couch db:'test';allApps;forEachApp:('console.log(appName+" "+appPath+" "+ddoc');onSuccess:'done')
		equals: self function , '.couch.db("test").allApps({"success":function(data){done},"eachApp":function(appName,appPath,ddoc){console.log(appName+" "+appPath+" "+ddoc}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testMquery

self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}})'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}})'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testOview

	self
		assert: (self jQuery couch db:'test';view:('default/all');onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").view("default/all",{"reduce":false,"success":function(data){done},"error":function(status){err}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testPlist

	self
		assert: (self jQuery couch db:'test';list:('default/all') with:'all';onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").list("default/all","all",{"reduce":false,"success":function(data){done},"error":function(status){err}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testQcompact

	self
		assert: (self jQuery couch db:'test';compact;onSuccess:'done')
		equals: self function , '.couch.db("test").compact({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testRviewCleanup

	self
		assert: (self jQuery couch db:'test';viewCleanup;onSuccess:'done')
		equals: self function , '.couch.db("test").viewCleanup({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testScompactView

	self
		assert: (self jQuery couch db:'test';compactView:'default';onSuccess:'done')
		equals: self function , '.couch.db("test").compactView("default",{"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testTchange

	self
		assert: (self jQuery couch db:'test';onChange:'done')
		equals: self function , '.couch.db("test").changes().onChange(function(data){done})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testUdrop

	self
		assert: (self jQuery couch db:'test';drop;onSuccess:'done')
		equals: self function , '.couch.db("test").drop({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testVcopyDoc

	self
		assert: (self jQuery couch db:'test';copyDoc:'11111';onSuccess:'done';onError:'err';beforeSend:'send')
		equals: self function , '.couch.db("test").copyDoc("11111",{"success":function(data){done},"error":function(status){err}},{"beforeSend":function(xhr){send}})'.
		
	! !

!JQueryCouchTest class methodsFor: 'testing' stamp: 'JesusMari 3/30/2012 23:13'!
isAbstract
	^ self name = #JQueryTest! !

!JQueryCouchTest class methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
packageNamesUnderTest
	^ #('JQuery-Core')! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
function
	"Answers the name of the jQuery function. This can be either '$' or 'jQuery' or any other user chosen name. This makes sure the tests run in any case."

	^ JQuery functionName! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery
	^ JQueryClass context: self renderContext! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery: anObject
	^ self jQuery with: anObject! !
